"use strict"; // Is this statement unnecessary? Yup, but it's staying.

// Constants
      // Base paths
const CT_TEXT  = "text/plain", // For responses only
      CT_JSON  = "application/json",
      CT_QUERY = "application/x-www-form-urlencoded",
      // Error codes
      ERR_REQ_NETWORK = 0, // Network error occurred
      ERR_REQ_SERVER  = 1, // Server responded with a non-200 status
      ERR_REQ_RESP_ENCODING = 2, // Bad encoding
      ERR_POP_AUTH = 3, // Invalid account credentials
      ERR_SAVE_MAX = 4, // Save data maxed out
      ERR_EXT_MNT  = 5, // Server maintenance
      ERR_EXT_UPD  = 6, // Extension update required
      // Port names
      PORT_P = "p",
      PORT_C = "c",
      PORT_E = "e",
      // Port commands
            // Global commands (0-99)
            // Popup commands (100-199)
            CMD_POPUP_LOGIN  = 100,
            CMD_POPUP_LOGOUT = 101,
            CMD_POPUP_GET_QUESTS = 102,
            CMD_POPUP_QUEST_LAUNCH = 103,
            CMD_POPUP_QUEST_STATUS = 104,
            CMD_POPUP_QUEST_TAB = 105,
            // Content commands (200-299)
            CMD_CONTENT_SWITCH_TO_EXT = 200,
            // External commands are strings
      // Port arguments
            // Global arguments
            // Popup arguments
            ARG_POPUP_INIT_SECTION_LOGIN = 0,
            ARG_POPUP_INIT_SECTION_MAIN  = 1,
      // Progress values
      PROGRESS_NONE = 0,
      PROGRESS_STARTED  = 1,
      PROGRESS_COMPLETE = 2,
      PROGRESS_PLAYING  = 3, // Only used by popup.
      // Prize types
      PRIZE_NONE = "noPrize",
      PRIZE_CREDITS = "credits",
      PRIZE_ROLE = "role",
      PRIZE_ROLE_CODELESS = "codelessRole",
      // Misc.
      QUERY_POP_LAUNCH = "?" + chrome.runtime.id;